import numpy as np


def load_raster(filename):
    raster = np.genfromtxt(filename,delimiter=',',invalid_raise=False)
    return raster

def spike_count_onebin(neuron_ind, spike_times,n_neurons,t_window):
    '''
    Retuns a vector of length n_neurons with the spike count (not rate) in a given time_bin
    '''
    t_start, t_end = t_window
    sc = np.zeros(n_neurons)
    relevant_indices = np.nonzero((spike_times >= t_start) & (spike_times < t_end))[0]
    relevant_neuron_ind = neuron_ind[relevant_indices]
    n_spikes = len(relevant_indices)
    for k_spike in xrange(n_spikes):
        ind1 = relevant_neuron_ind[k_spike]
        sc[ind1] += 1.
    return sc

def sliding_win_on_circ_data(data_mat,window_width,axis=0):
    smaller_half = np.floor((window_width)/2)
    bigger_half = np.ceil((window_width)/2)
    sum_up_mat = np.zeros(np.shape(data_mat))
    for k_circ in xrange(-int(smaller_half),int(bigger_half+np.mod(window_width,2))):
        sum_up_mat += np.roll(data_mat,-k_circ,axis)
    return sum_up_mat/window_width




